;----------------------------------------------------------
; SPACEWARS in AutoLISP   Version 1.0
; Bill Kramer April 1992
; PUBLIC DOMAIN SOFTWARE
; 
; This program is meant to be further hacked for the shear pleasure of it.
; No warrenties, no support, just have fun.
;---------------------------------------------------
;
(setq TURN_ANG1 (/ PI 20)
      TURN_ANG2 (/ PI 20)
      TURN_TIME 0.000005787 ; increase for slower machines
      SHIPS ; Nam MxV TT  TC TDP DFP  SIZ  ACC   Turn
       (list 
        (list "1" 3.0 35  25 0.6 1.0  1.0  4.0   (/ PI 20))
        (list "2" 2.0 70  25 0.7 1.5  1.5  10.0  (/ PI 30))
        (list "3" 1.5 100 25 1.1 3.0  2.5  25.0  (/ PI 60))
        (list "4" 1.0 100 50 2.1 12.0 5.0  50.0  (/ PI 80))
       )
)

(setvar "CMDECHO" 0)
(setvar "BLIPMODE" 0)
(command ".INSERT" "SPACE" (list 0 0 0) 1 1 0
         ".ERASE" (entlast) "")
;
;----------------------------------------------------------
(defun C:SW ()
   (setupvars)
   (setq NO_STOP nil)
   (prompt "\nGame about to start, move crosshairs out of screen area.")
   (prompt "\nShip 1: (A) left (S) thruster (D) right (F) fire")
   (prompt "\nShip 2: (J)      (K)          (L)       (;)")
   (getstring)
   (setq GAME_ON 'T)
   (prompt "\nBattle start")
   (while GAME_ON
         (grtext -1 (strcat "Ship 1 T = " (itoa S1_AMMO)
                            " D = " (rtos S1_DEF)))
         (grtext -2 (strcat "Ship 2 T = " (itoa S2_AMMO)
                            " D = " (rtos S2_DEF)))
         (setq KEY (grread 'T))
         (if KEY (key_action KEY))
         (move_action)
   )
   (command ".REDRAW")
   (if (and T1_OBJ (entget (last T1_OBJ))) (entdel (last T1_OBJ)))
   (if (and T2_OBJ (entget (last T2_OBJ))) (entdel (last T2_OBJ)))
   (setq T1_OBJ nil T2_OBJ nil
         T1_LIFE -1 T2_LIFE -1)
   (entdel (last S1_OBJ))
   (entdel (last S2_OBJ))
   (cond
     ((and (minusp S1_DEF) (minusp S2_DEF))
        (prompt "\nBoth ships destroyed, better luck next time")
     )
     ((minusp S1_DEF)
        (prompt "\nShip 2 is victorious!")
     )
     ((minusp S2_DEF)
        (prompt "\nShip 1 is victorious!")
     )
   )
   (princ)
)
;
;----------------------------------------------------------
(defun SETUPVARS ()
   (setq USCALE (/ (getvar "VIEWSIZE") 100.0)
         T1_LIFE -1
         T2_LIFE -1
         T1_OBJ nil
         T2_OBJ nil
   )
   (if (or (null UMIN) (null UMAX))
     (setq
         UMIN (getpoint "\nLower left corner of Universe: ")
         UMAX (getpoint "\nUpper right corner of Universe: ")
     )
   )
   (command ".VSLIDE" "SPACE")
   (initget 0 "1 2 3 4")
   (setq TMP (getkword "\nPick ship 1 type <1>: "))
   (if (null TMP) (setq TMP "1"))
   (command ".REDRAW")
   (setq S1_OBJ (list
                  (getpoint "\nLocate initial placement:")
                  (/ (* USCALE (cadr (assoc TMP SHIPS))) 4.0)
                  (getangle "\nInitial angle:")
                  (* USCALE (nth 6 (assoc TMP SHIPS)))
   ))
   (command ".INSERT" (strcat "S" TMP) (car S1_OBJ)
            USCALE ""
            (angtos (caddr S1_OBJ)))
   (setq S1_OBJ (append S1_OBJ (list (entlast)))
         TORP1_LIFE (nth 2 (assoc TMP SHIPS))
         TORP1_DMG (nth 4 (assoc TMP SHIPS))
         S1_DEF (nth 5 (assoc TMP SHIPS))
         S1_MAXV (* USCALE (nth 1 (assoc TMP SHIPS)))
         S1_AMMO (nth 3 (assoc TMP SHIPS))
         S1_ACC (nth 7 (assoc TMP SHIPS))
         TURN_ANG1 (nth 8 (assoc TMP SHIPS))
   )
   ; Nam MxV TT  TC TDP DFP SIZ ACC TURN
   (command ".VSLIDE" "SPACE")
   (initget 0 "1 2 3 4")
   (setq TMP (getkword "\nPick ship 2 type <1>: "))
   (if (null TMP) (setq TMP "1"))
   (command "REDRAW")
   (setq S2_OBJ (list
                  (getpoint "\nLocate initial placement:")
                  (/ (* USCALE (cadr (assoc TMP SHIPS))) 4.0)
                  (getangle "\nInitial angle:")
                  (* USCALE (nth 6 (assoc TMP SHIPS)))
   ))
   (command ".INSERT" (strcat "S" TMP) (car S2_OBJ)
             USCALE ""
            (angtos (caddr S2_OBJ)))
   (setq S2_OBJ (append S2_OBJ (list (entlast)))
         TORP2_LIFE (nth 2 (assoc TMP SHIPS))
         TORP2_DMG (nth 4 (assoc TMP SHIPS))
         S2_DEF (nth 5 (assoc TMP SHIPS))
         S2_MAXV (* USCALE (nth 1 (assoc TMP SHIPS)))
         S2_AMMO (nth 3 (assoc TMP SHIPS))
         S2_ACC (nth 7 (assoc TMP SHIPS))
         TURN_ANG2 (nth 8 (assoc TMP SHIPS))
   )
)

;----------------------------------------------------------
;
(defun KEY_ACTION (KEY)
  (if (= (car KEY) 2)
    (progn
      (setq KEY (strcase (chr (cadr KEY))))
      (cond
        ((= KEY "S")
           (prompt "\nShip 1: Thruster fire")
           (setq S1_OBJ (thrust S1_OBJ S1_MAXV S1_ACC)))
        ((= KEY "A")
           (prompt "\nShip 1: Turn left")
           (turn S1_OBJ TURN_ANG1))
        ((= KEY "D")
           (prompt "\nShip 1: Turn right")
           (turn S1_OBJ (* -1 TURN_ANG1)))
        ((= KEY "F")
           (prompt "\nShip 1: Fire request")
           (if (and (null T1_OBJ) (> S1_AMMO 0))
              (setq T1_OBJ (fire S1_OBJ 4)
                    S1_AMMO (1- S1_AMMO)
                    T1_LIFE TORP1_LIFE)
           ))
        ((= KEY "K")
           (prompt "\nShip 2: Thruster fire")
           (setq S2_OBJ (thrust S2_OBJ S2_MAXV S2_ACC)))
        ((= KEY "J")
           (prompt "\nShip 2: Turn left")
           (turn S2_OBJ TURN_ANG2))
        ((= KEY "L")
           (prompt "\nShip 2: Turn right")
           (turn S2_OBJ (* -1 TURN_ANG2)))
        ((= KEY ";")
           (prompt "\nShip 2: Fire request")
           (if (and (null T2_OBJ) (> S2_AMMO 0))
              (setq T2_OBJ (fire S2_OBJ 2)
                    S2_AMMO (1- S2_AMMO)
                    T2_LIFE TORP2_LIFE)
           ))
      )
    )
  )
)
;----------------------------------------------------------
;
;  MOVE_ACTION  Updates objects on the screen
;
(defun MOVE_ACTION ()
   (setq VMAX (list (cadr S1_OBJ) (cadr S2_OBJ)))
   (if T1_OBJ (setq VMAX (cons (cadr T1_OBJ) VMAX)))
   (if T2_OBJ (setq VMAX (cons (cadr T2_OBJ) VMAX)))
   (setq VMAX (apply 'max VMAX)
         TT (/ VMAX USCALE)  
         RTC (getvar "DATE")
         CNT 0
   )
   (if (not (zerop TT))
     (while (< CNT (1+ (fix TT)))
        (setq S1_OBJ (move_obj S1_OBJ (/ (cadr S1_OBJ) TT))
              S2_OBJ (move_obj S2_OBJ (/ (cadr S2_OBJ) TT))
              GAME_ON (hit_miss S1_OBJ S2_OBJ))
        (if (null GAME_ON) 
           (progn
              (prompt "\nBoth ships destroyed!")
              (setq S1_DEF -1.0
                    S2_DEF -1.0)
           )
        )
        (if (and T1_OBJ (> T1_LIFE 0))
          (progn
            (setq T1_OBJ (move_obj T1_OBJ (/ (cadr T1_OBJ) TT))
                  T1_LIFE (1- T1_LIFE)
                  GAME_ON (hit_miss T1_OBJ S2_OBJ))
            (if (null GAME_ON)
              (progn
               (entdel (last T1_OBJ))
               (setq S2_DEF (- S2_DEF TORP1_DMG)
                     T1_OBJ nil
                     TURN_ANG2 (- TURN_ANG2 (/ TURN_ANG2 4))
                     S2_ACC (- S2_ACC (/ S2_ACC 4))
                     T1_LIFE -1)
               (if (minusp S2_DEF)
                  (prompt "\nShip 2 destroyed!")
                  (setq GAME_ON 'T)
               )
              )
            )
          )
        )
        (if (and T2_OBJ (> T2_LIFE 0))
          (progn
            (setq T2_OBJ (move_obj T2_OBJ (/ (cadr T2_OBJ) TT))
                  T2_LIFE (1- T2_LIFE)
                  GAME_ON (hit_miss T2_OBJ S1_OBJ))
            (if (null GAME_ON)
              (progn
                (entdel (last T2_OBJ))
                (setq S1_DEF (- S1_DEF TORP2_DMG)
                      T2_OBJ nil
                      TURN_ANG1 (- TURN_ANG1 (/ TURN_ANG1 4))
                      S1_ACC (- S1_ACC (/ S1_ACC 4))
                      T1_LIFE -1)
                (if (minusp S1_DEF)
                  (prompt "\nShip 1 destroyed!")
                  (setq GAME_ON 'T)
                )
              )
            )
          )
        )
        (if (and GAME_ON T1_OBJ T2_OBJ)
           (if (null (hit_miss T1_OBJ T2_OBJ))
              (setq T1_OBJ (entdel (last T1_OBJ))
                    T2_OBJ (entdel (last T2_OBJ))
                    T1_OBJ nil
                    T2_OBJ nil
                    T1_LIFE -1
                    T2_LIFE -1
              )
           )
        )
        (setq CNT (1+ CNT))
        (if (null GAME_ON) (setq CNT (1+ TT)))
        (setq KEY (grread 'T))
        (if KEY (key_action KEY))
     )
   )
   (while (< (- (getvar "DATE") RTC) TURN_TIME)) 
   (if (zerop S1_AMMO) (prompt "\nShip 1 out of ammunition."))
   (if (Zerop S2_AMMO) (prompt "\nShip 2 out of ammunition."))
   (if (zerop T1_LIFE)
      (progn
        (entdel (last T1_OBJ))
        (torp_expl T1_OBJ)
        (setq T1_OBJ nil T1_LIFE -1)
      )
   )
   (if (zerop T2_LIFE)
      (progn
        (entdel (last T2_OBJ))
        (torp_expl T2_OBJ)
        (setq T2_OBJ nil T2_LIFE -1)
      )
   )
)
;----------------------------------------------------------
;
;  Update THRUST vectors for object
;
(defun THRUST (OBJ MAXV VINC)
  (setq V1 (polar (list 0 0) 
                  (caddr OBJ) 
                  (cadr OBJ))
        V2 (polar (list 0 0) 
                  (cdr (assoc 50 (entget (last OBJ))))
                  (/ USCALE VINC))
        V1 (mapcar '+ V1 V2)
  )
  (if (> (distance (list 0 0) V1) MAXV)
     (setq V1 (polar (list 0 0) (angle (list 0 0) V1) MAXV)))
  (list (car OBJ) 
        (distance (list 0 0) V1)
        (angle (list 0 0) V1)
        (cadddr OBJ)
        (last OBJ)
  )
)
;----------------------------------------------------------
;
;  TURN an object
;
(defun TURN (OBJ ANG)
  (setq EL (entget (last OBJ))
        EL (subst (cons 50 (+ (cdr (assoc 50 EL)) ANG))
                  (assoc 50 EL)
                  EL)
  )
  (entmod EL)
)

;----------------------------------------------------------
; Fire Control
;
(defun FIRE (OBJ CLR)
  (entmake (list 
     (cons 0 "CIRCLE") 
     (cons 8 "0")
     (cons 62 CLR)
     (cons 10 (car OBJ))
     (cons 40 (/ USCALE 2))
  ))
  (setq EL (entget (entlast)))
  (list (cdr (assoc 10 EL))
        (* USCALE 5)
        (cdr (assoc 50 (entget (last OBJ))))
        USCALE
        (entlast)
  )
)

;----------------------------------------------------------
;
;  hit_miss determination
;  return 'T if miss, nil if hit.
;
(defun HIT_MISS (M_OBJ T_OBJ)
  (setq DD (distance (car M_OBJ) (car T_OBJ)))
  (if (and (> DD (+ (cadddr M_OBJ) (cadddr T_OBJ))) GAME_ON)
     'T ;; No hit
     (explosion M_OBJ)
  )
)

;----------------------------------------------------------
;
(defun EXPLOSION (OBJ / CNT)
  (setq CNT 0.5)
  (repeat 10
     (entmake (list 
       (cons 0 "CIRCLE") 
       (cons 8 "0") 
       (cons 62 1) 
       (cons 10 (car OBJ))
       (cons 40 (* CNT USCALE))
     ))
     (setq EN (entlast))
     (repeat 11
       (entdel EN))
     (setq CNT (+ CNT 0.5))
  )
  nil
)
;----------------------------------------------------------
(defun TORP_EXPL (OBJ / CNT)
  (setq CNT 0.5)
  (repeat 2
     (entmake (list 
       (cons 0 "CIRCLE") 
       (cons 8 "0") 
       (cons 62 1) 
       (cons 10 (car OBJ))
       (cons 40 (* CNT USCALE))
     ))
     (setq EN (entlast))
     (repeat 5
       (entdel EN))
     (setq CNT (+ CNT 0.5))
  )
  nil
)

;----------------------------------------------------------
;
(defun MOVE_OBJ (OBJ FAR / P1 EL)
   (setq P1 (polar (car OBJ) (caddr OBJ) FAR))

   (if (< (car P1) (car UMIN)) (setq P1 (list (car UMAX) (cadr P1) 0.0)))
   (if (< (cadr P1) (cadr UMIN)) (setq P1 (list (car P1) (cadr UMAX) 0.0)))
   (if (> (car P1) (car UMAX)) (setq P1 (list (car UMIN) (cadr P1) 0.0)))
   (if (> (cadr P1) (cadr UMAX)) (setq P1 (list (car P1) (cadr UMIN) 0.0)))
   (if (or (= (length P1) 2) (/= (caddr P1) 0.000))
      (setq P1 (list (car P1) (cadr P1) 0.0)))
   (setq EL (entget (last OBJ))
         EL (subst (cons 10 P1) (assoc 10 EL) EL)
   )
   (entmod EL)
   (cons P1 (cdr OBJ))
)
;
(prompt "\nTurn OFF UNDO system before playing!")
(prompt "\nSpace Wars is loaded, enter SW to start battle....")
(princ)
